/*
  ORDXTRN.C			noviembre / 1999
  Orden externo-ordena los registros de un archivo desordenado en uno ordenado
*/
//OJO> se utiliza el programa NOMBRES.C para generar la lista de nombres
//Utiliza el archivo NAMES.TXT que genera NOMBRES.C y genera dos archivos:
//ORDEN.TXT que es la version ordenada de NAMES.TXT y ORDEN.DAT que contiene
//el arbol B de las llaves ordenadas
//Estos arhivos pueden llegar a ser bastante grandes
#include <time.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define ORDEN 5
#define LENKEY 8
#define MAXSTACK 100

enum BOOL {FALSE,TRUE};

struct btree
{
	int numtrees;			//cuantos hijos tiene el nodo
	char key[ORDEN-1][50];		//llaves (numeros de boleta)
	long reg[ORDEN-1];		//apuntadores en el desordenado
	long son[ORDEN];		//apuntadores en el ordenado
};

struct stack
{
	int tope;
	long datos[MAXSTACK];	//datos: posicion de un nodo en el archivo
};

struct narr
{
	char llaves[50];
	long reg;
	long hijo;
};

long ordenar(FILE *, FILE *, int);
void ininodo(struct btree *);
enum BOOL empty(struct stack *);
enum BOOL push(struct stack *, long);
enum BOOL pop(struct stack *, long *);
void insertar(struct stack *, struct btree *, char *, long, long, long *, FILE *);
void print(FILE *, FILE *, FILE *, long);
enum BOOL search(char *, FILE *, FILE *, long);

void main()
{
	char origen[128]={"names.txt"};
	char destino[128]={"orden.txt"};
	char opc;
	char cadena[128];
	FILE *d, *e, *f;
	int tipo=1;	//tipo=1> la llave es el numero de boleta
	long raiz;	//tipo=2> la llave es el nombre y apellidos
	clock_t beg, end;

	clrscr();
/*	puts("Path y Nombre de archivo origen:");
	gets(origen);
	puts("Path y Nombre de archivo destino:");
	gets(destino);
	puts("Tipo de ordenacion:");
	puts("1.- por nmero de boleta");
	puts("2.- por apellido paterno");
	scanf("%d",&tipo);*/

	if(!(d=fopen(origen,"rb")))		//archivo desordenado
	{
		puts("Error de lectura, archivo origen");
		exit(1);
	}
	if(!(e=fopen(destino,"w+b")))		//archivo ordenado
	{
		puts("Error de escritura, archivo destino");
		exit(1);
	}
	if(!(f=fopen("ORDEN.DAT","w+b")))	//archivo del rbol
	{
		puts("Error de escritura, archivo de datos");
		exit(1);
	}

	beg=clock();
	raiz=ordenar(f,d,tipo);
	end=clock();
	printf("\nTiempo de ejecucion del ordenamiento: %g segundos\n",(float)(end-beg)/CLK_TCK);
	getch();
	while(1)
	{
		clrscr();
		printf("Elige una opcion:\n\n");
		printf("1) Mostrar los elementos ordenados y guardarlos en el archivo ORDEN.TXT\n");
		printf("2) Buscar un elemento de los registros por medio de su llave\n");
		printf("3) Salir\n\n");
		scanf("%c",&opc);
		switch(opc)
		{
			case '1':
				print(f,d,e,raiz);
				getch();
				break;
			case '2':
				fflush(stdin);
				printf("Escribe la llave que quieres buscar: ");
				gets(cadena);
				if(!search(cadena,f,d,raiz))
					printf("No se encuentra el elemento!");
				getch();
				break;
			case '3':
				fclose(d);
				fclose(e);
				fclose(f);
				exit(1);
			default:
				printf("Opcion incorrecta!");
            getch();
		}
	}
}

/*Ordena los registros del archivo orig y los guarda en el archivo dest*/
long ordenar(FILE *f, FILE *d, int tipo)
{
	struct btree nodo={0};
	struct stack s={0};
	long raiz=-1, root, pos;
	char llave[50], cad[128];
	int l, j;
	long clave=0;

	//1eros 4 bytes: posicion de la raiz en el archivo del arbol
	fwrite(&raiz,sizeof(raiz),1,f);	//inicializar con -1 = arbol vacio
	printf("Registro #");
	while(!feof(d))//hasta acabar de leer las lineas del archivo desordenado
	{
		s.tope=-1;		//inicializar la pila
		pos=ftell(d);
		fgets(cad,128,d);	//lee la siguiente cadena
		if(feof(d))
			break;
		clave++;
		gotoxy(11,1);
		printf("%ld",clave);
		fseek(d,pos,SEEK_SET);
		j=0;
		if(tipo==1)		//ordenar por numero de boleta
			for(l=0;l<LENKEY;l++)
				llave[j++]=cad[l];
		else			//ordenar por apellidos y nombre
			for(l=LENKEY;cad[l]!='\0' && l<50; l++)
				llave[j++]=cad[l];
		llave[j]='\0';
		if(raiz==-1)		//arbol vacio: 1er nodo
		{
			ininodo(&nodo);
			strcpy(nodo.key[0],llave);
			nodo.reg[0]=ftell(d)+LENKEY;//reg. (sin numero de boleta)
			raiz=ftell(f);
			rewind(f);
			fwrite(&raiz,sizeof(raiz),1,f);
			fwrite(&nodo,sizeof(nodo),1,f);
			fflush(f);
		}
		else
		{
			rewind(f);
			fread(&root,sizeof(root),1,f);
			fseek(f,root,SEEK_SET);
			pos=ftell(f);
			fread(&nodo,sizeof(nodo),1,f);
			fseek(f,pos,SEEK_SET);
			while(nodo.numtrees>0)//movernos al nodo donde va el dato
			{
				for(l=0; l<ORDEN-1 &&
					strcmp(llave,nodo.key[l])>0 &&
					strcmp(nodo.key[l],""); l++);
				push(&s,ftell(f));
				fseek(f,nodo.son[l],SEEK_SET);
				pos=ftell(f);
				fread(&nodo,sizeof(nodo),1,f);
				fseek(f,pos,SEEK_SET);
			}
			insertar(&s,&nodo,llave,ftell(d)+LENKEY,-1,&raiz,f);
		}
		fseek(d,strlen(cad),SEEK_CUR);
	}
	return raiz;
}

/*Inicializa un nuevo nodo*/
void ininodo(struct btree *node)
{
	int i;

	node->numtrees=0;		//no hay hijos
	for(i=0;i<ORDEN-1;i++)
	{
		strcpy(node->key[i],"");//sin llaves validas
		node->reg[i]=-1;	//apuntadores a -1
		node->son[i]=-1;
	}
	node->son[i]=-1;		//ultimo apuntador a -1
}

/*Verifica si la pila esta vacia*/
enum BOOL empty(struct stack *p)
{
	return((p->tope==-1)?TRUE:FALSE);
}

/*Mete elemento hasta arriba en la pila*/
enum BOOL push(struct stack *p, long n)
{
	if(p->tope==MAXSTACK-1)
		return FALSE;
	p->datos[++(p->tope)]=n;
	return TRUE;
}

/*Saca elemento de hasta arriba de la pila*/
enum BOOL pop(struct stack *p, long *n)
{
	if(empty(p))
		return FALSE;
	*n=p->datos[p->tope--];
	return TRUE;
}

/*Inserta una llave en un nodo de un arbol B*/
void insertar(struct stack *s, struct btree *nodo, char *k, long nf, long hijo,
							long *r, FILE *f)
{
	int l, j, e, numhijos;
	long bro, papa, yo, ultimo, temp;
	struct narr a[ORDEN]={0};
	struct btree hermano={0}, padre={0};

	for(l=0; l<ORDEN-1 && strcmp(nodo->key[l],""); l++);//cuantas llaves tiene el nodo?
	if(l<ORDEN-1)		//aun le caben al nodo
	{
		if(l==0 || strcmp(k,nodo->key[l-1])>0)//queda al final del arreglo
		{
			strcpy(nodo->key[l],k);
			nodo->reg[l]=nf;
			nodo->son[l+1]=hijo;
		}
		else		//hay que acomodarlo
		{																	//buscar posicion
			for(j=0; strlen(nodo->key[j])>0 && strcmp(k,nodo->key[j])>0; j++);
			nodo->son[l+1]=nodo->son[l]; //recorre el ultimo de los hijos
			for(e=l-1; e>=j; e--)//recorrer los que quedan despues
			{
				strcpy(nodo->key[e+1],nodo->key[e]);
				nodo->reg[e+1]=nodo->reg[e];
				nodo->son[e+1]=nodo->son[e];
			}
			strcpy(nodo->key[j],k);
			nodo->reg[j]=nf;
			nodo->son[j+1]=hijo;
		}
		if(hijo>=0)
			nodo->numtrees++;
		fwrite(nodo,sizeof(*nodo),1,f);
	}
	else	//si ya no le caben, sube el del medio al nodo padre
	{
		for(l=0;l<ORDEN-1;l++)	//a un arreglo auxiliar: info del nodo
		{
			strcpy(a[l].llaves,nodo->key[l]);
			a[l].reg=nodo->reg[l];
			a[l].hijo=nodo->son[l];
		}
		ultimo=nodo->son[l];	//guarda el ultimo de los hijos
		for(j=0; strlen(a[j].llaves)>0 && strcmp(k,a[j].llaves)>0; j++);//busca el lugar
		if(strcmp(k,a[l-1].llaves)>0)	//copia al final del arreglo
		{
			strcpy(a[l].llaves,k);
			a[l].reg=nf;
			a[l].hijo=hijo;
		}
		else				//o lo acomoda en el lugar
		{
			for(e=l-1; e>=j; e--)	//acomoda los registros del arreglo a
			{
				strcpy(a[e+1].llaves,a[e].llaves);
				a[e+1].reg=a[e].reg;
				a[e+1].hijo=a[e].hijo;
			}
			strcpy(a[j].llaves,k);
			a[j].reg=nf;
			a[j].hijo=hijo;
		}

		for(l=0; l<ORDEN/2; l++)//nodo original queda con los 2 1eros del arreglo
		{
			strcpy(nodo->key[l],a[l].llaves);
			nodo->reg[l]=a[l].reg;
			nodo->son[l]=a[l].hijo;
		}
		if(j<ORDEN/2)	//si el nuevo elemento quedara antes de la mitad del nodo
		{							//original, para evitar desordenar hijos hace un intercambio
			nodo->son[l]=a[l].hijo;
			temp=nodo->son[j];
			nodo->son[j]=nodo->son[j+1];
			nodo->son[j+1]=temp;
		}
		numhijos=0;
		for(l=ORDEN-2; l>ORDEN/2-1; l--)	//elimina el resto de datos del nodo
		{
			strcpy(nodo->key[l],"");
			nodo->reg[l]=-1;
			if(nodo->son[l+1]>=0)
				numhijos++;
			nodo->son[l+1]=-1;
		}
		nodo->numtrees-=numhijos;
		yo=ftell(f);
		fwrite(nodo,sizeof(*nodo),1,f);	//re-escribe el nodo original modificado

		ininodo(&hermano);//hermano queda con los 2 ultimos del arreglo
		hermano.numtrees=numhijos;
		for(l=0; l<ORDEN/2; l++)
		{
			strcpy(hermano.key[l],a[ORDEN/2+1+l].llaves);
			hermano.reg[l]=a[ORDEN/2+1+l].reg;
			if(l==0 && (!strcmp(k,a[ORDEN/2].llaves)))
				hermano.son[l]=a[ORDEN/2].hijo;
			else
				hermano.son[l]=a[ORDEN/2+1+l].hijo;
		}
		hermano.son[l]=ultimo;
		if(j>ORDEN/2)	//si el nuevo elemento quedara luego de la mitad del nodo
		{							//original, para evitar desordenar hijos hace un intercambio
			temp=hermano.son[j-ORDEN/2-1];
			hermano.son[j-ORDEN/2-1]=hermano.son[j-ORDEN/2];
			hermano.son[j-ORDEN/2]=temp;
		}
		fseek(f,0L,SEEK_END);
		bro=ftell(f);
		fwrite(&hermano,sizeof(hermano),1,f);//escribe el hermano al final del archivo

		if(!pop(s,&papa))//si no hay papa arriba
		{
			ininodo(&padre);	//lo crea
			fseek(f,0L,SEEK_END);
			papa=ftell(f);
			padre.son[0]=yo;	//inserta nodo original como hijo izquierdo
			padre.numtrees++;
			fwrite(&padre,sizeof(padre),1,f);	//escribe el padre al final del archivo
			rewind(f);
			*r=papa;//como no habia padre, el nuevo padre se convierte en la nueva raiz
			fwrite(&papa,sizeof(papa),1,f);
			fseek(f,papa,SEEK_SET);
			fflush(f);	//el hijo derecho es el hermano
			insertar(s,&padre,a[ORDEN/2].llaves,a[ORDEN/2].reg,bro,r,f);
		}
		else		//si si hay papa
		{
			fseek(f,papa,SEEK_SET);	//se va al papa
			fread(&padre,sizeof(padre),1,f);
			fseek(f,papa,SEEK_SET);
			fflush(f);//inserta hermano (el original ya estaba insertado)
			insertar(s,&padre,a[ORDEN/2].llaves,a[ORDEN/2].reg,bro,r,f);
		}
	}
	fflush(f);
}

/*Imprime y guarda los registros del archivo ya ordenado*/
void print(FILE *f, FILE *d, FILE *e, long T)
{
	int i;
	char cad[128], cbol[LENKEY+1], dato[128+LENKEY+2], aux[50];
	long auxpos;
	struct btree nodo={0};
	static unsigned long screen=1;

	/*Recorrido en "inorden"*/
	if(T>=0)
	{
		fseek(f,T,SEEK_SET);
		fread(&nodo,sizeof(nodo),1,f);	//leer nodo
		for(i=0;i<ORDEN-1;i++)	//recorrer su arreglo de llaves
		{
			print(f,d,e,nodo.son[i]);//ir a sus hijos primero
			if(strcmp(nodo.key[i],""))	//si existe la llave
			{
				fseek(d,nodo.reg[i],SEEK_SET);
				auxpos=ftell(d);
				fgets(cad,128,d);	//lee el registro
				fseek(d,auxpos-LENKEY,SEEK_SET);
				fread(cbol,sizeof(char),LENKEY,d);//y la boleta
				cbol[LENKEY]='\0';
				if((screen+1)%23 == 0)
					getch();
				strcpy(dato,itoa(screen++,aux,10));
				strcat(dato," ");
				strcat(dato,cbol);
				strcat(dato,cad);
				auxpos=ftell(e);
				fwrite(dato,sizeof(char),strlen(dato),e);
				fseek(e,auxpos,SEEK_SET);
				fread(dato,sizeof(char),strlen(dato)+1,e);
				printf("%s",dato);//escribe datos
			}
		}
		print(f,d,e,nodo.son[i]);	//ultimo hijo
	}
}

/*Busca una llave en los registros*/
enum BOOL search(char *cad, FILE *arbol, FILE *registros, long root)
{
	int l;
	long pos;
	struct btree nodo;
	char datos[128];

	if(root<0)		//si la raiz es invalida
		return FALSE;
	fseek(arbol,root,SEEK_SET);	//vamos a la raiz
	fread(&nodo,sizeof(nodo),1,arbol);	//leemos el nodo raiz

	do
	{
		for(l=0; l<ORDEN-1 &&				//buscamos en las llaves hasta encontrar
			strcmp(cad,nodo.key[l])>0 &&	//por donde irse en el arbol
			strcmp(nodo.key[l],""); l++);
		if(!strcmp(cad,nodo.key[l]))	//comparamos si es que ya llegamos a la llave
		{
			fseek(registros,nodo.reg[l],SEEK_SET);
			fgets(datos,127,registros);
			printf("%s",datos);
			getch();
			return TRUE;
		}
		if(nodo.numtrees<0)		//si no hay hijos, no encontro nada
			break;
		fseek(arbol,nodo.son[l],SEEK_SET);	//o nos vamos al hijo correcto
		pos=ftell(arbol);
		fread(&nodo,sizeof(nodo),1,arbol);
		fseek(arbol,pos,SEEK_SET);
	}while(1);//hasta encontrar el dato o llegar a que no tiene hijos y por
	return FALSE;	//tanto no esta el dato
}
